# 
# The contents of this file are subject to the Mozilla Public
# License Version 1.1 (the "License"); you may not use this file
# except in compliance with the License. You may obtain a copy of
# the License at http://www.mozilla.org/MPL/
# 
# Software distributed under the License is distributed on an "AS
# IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
# implied. See the License for the specific language governing
# rights and limitations under the License.
# 
# The Original Code is "Java-Python Extension (JPE)".
# 
# The Initial Developer of the Original Code is Frederic Bruno Giacometti.
# Portions created by Frederic Bruno Giacometti are
# Copyright (C) 2000-2001 Frederic Bruno Giacometti. All Rights Reserved.
# 
# Contributor(s): frederic.giacometti@arakne.com
#
# Acknowledgments:
# Particular gratitude is expressed to the following parties for their
# contributing support to the development of JPE:
#     - Arakne SARL (France) and its staff (http://www.arakne.com);
#       and in particular to Jean Hemmi, Marie-Therese Plaze and Didier Rano
#     - The European Union through its funding of the IST Alice project
#     - Dean Vucinic from Vrije Universiteit Brussel (Belgium),
#       coordinator of the IST Alice project
#     - iPhrase Technologies Inc. (Massachusetts, USA)
#

PYTHON=$(shell python$(DBGEXT) -c 'import sys; print sys.executable') -t
PYTHONDIR=$(shell $(PYTHON) -c 'import sys; print sys.prefix')
PYTHONVERSION=$(shell $(PYTHON) -c 'import sys; print sys.version[ :3]')
#export PYTHONVERBOSE=x

## use PYSRCNAME and PYLIBNAME if working from a source distribution

#PYSRCNAME=Python-1.5.2
#PYLIBNAME=python15

#PYSRCNAME=Python-2.0
#PYLIBNAME=python20

PYSRCNAME=Python-2.1b1
PYLIBNAME=python21

MV=mv
RM=rm
TOUCH=touch
JAVAPATH=$(JPESRCDIR)
MEXT=$(DBGEXT).$(SOEXT)# python binary module extension

ifeq ($(PROCESSOR_ARCHITECTURE), x86)
WinEnv=1
endif

ifdef WinEnv
  #Windows config
  DBGEXT=_d
  ## Win32 ...
  MAKE_MODE=win32 # not working ?
  #TOUCH=echo "should touch"
  TOUCH=touch
  UNAME=$(UWIN)
### vars.bat must be edited and sourced first in jpe root source directory
  export JPESRCDIR=c:\local\src\jpe
  PYSRCDIR=c:/local/src/$(PYSRCNAME)
  PYINCLUDE=-I$(PYTHONDIR)\include -I$(PYTHONDIR)\PC
  PYLIB=$(PYTHONDIR)\PCBuild\$(PYLIBNAME)$(DBGEXT).lib
  #PYINCLUDE=-I$(PYSRCDIR)/PC -I$(PYSRCDIR)/Include
  #PYLIB=$(PYSRCDIR)/PCBuild/$(PYLIBNAME)$(DBGEXT).lib
  PYTHON=$(PYSRCDIR)/PCBuild/python$(DBGEXT)
  JDKDIR="c:/jdk1.3.0_02"
#  JVMLIB=$(JDKDIR)/lib/jvm.lib
  SOEXT=dll
  LIBPREF=
  OEXT=obj
  XEXT=.exe
  #CFLAGS=-Zi -W2 -nologo -Gy
  CFLAGS=-Zi -W3 -MDd -nologo -Ge -GD -Gy -GZ
  ## -DJPE_SINGLETHREAD
  ##  -TC
  CC=cl
  LINK=link -debug -nologo -warn:3 -map
  LINKEXE=$(LINK)
  LINKDLL=$(LINK) -dll
  JNIINCLUDES=-I$(JDKDIR)/include -I$(JDKDIR)/include/win32
  JAVASDKDIR=\jdk1.3.0_02
  export JRE_LIBJVM=$(JAVASDKDIR)\jre\bin\classic\jvm.dll
  JAVAC=$(JAVASDKDIR)\bin\javac -deprecation -classpath $(JAVAPATH)
  JAVAH=$(JAVASDKDIR)\bin\javah -force
  JAVA=$(JAVASDKDIR)\bin\java -verbose:jni,class\
 -Djava.library.path=$(JPESRCDIR) -Djava.class.path=$(JAVAPATH)
  JPELIB=jpe.lib
  export JRE_LIBDIR=$(JDKDIR)/jre/bin
  #export JRE_LIBJVM=$(JRE_LIBDIR)/classic/$(LIBPREF)jvm.$(SOEXT)
  PYMODEXT=
%.obj: %.c
	$(CC) $(CFLAGS) $(CPPFLAGS) -Fo$@ -c $<
else
  # Linux...
  UNAME=$(shell uname)
  #PYTHONINCLUDES=-I$(PYTHONDIR)/include/python$(PYTHONVERSION)
 #PYTHONLIB=$(PYTHONDIR)/lib/python$(PYTHONVERSION)/libpython$(PYTHONVERSION).a
  export JPESRCDIR=$(HOME)/local/src/jpe
  PYSRCDIR=$(HOME)/local/src/$(PYSRCNAME)
  PYINCLUDE=-I$(PYSRCDIR) -I$(PYSRCDIR)/Include
  PYLIB=$(PYSRCDIR)/$(LIBPREF)$(PYLIBNAME).$(SOEXT)
  #PYLIB=$(PYSRCDIR)/$(LIBPREF)python2.0.a
  JDKDIR=$(HOME)/local/src/jdk1.3.0_02
  LIBPREF=lib
  SOEXT=so
  OEXT=o
  XEXT=
  CFLAGS=-g -Wall -Wstrict-prototypes -Wmissing-prototypes -Wnested-externs
# -Wredundant-decls
  JNIINCLUDES=-I$(JDKDIR)/include -I$(JDKDIR)/include/linux
  export JRE_LIBDIR=$(JDKDIR)/jre/lib/i386
  export JRE_LIBJVM=$(JRE_LIBDIR)/server/$(LIBPREF)jvm.$(SOEXT)
#  export JRE_LIBJVM=$(JRE_LIBDIR)/classic/$(LIBPREF)jvm.$(SOEXT)
  export LD_LIBRARY=.:$(JPESRCDIR):$(JDKDIR)/lib/i386:$(JRE_LIBDIR):$(JRE_LIBDIR)/server
  export LD_LIBRARY_PATH=$(LD_LIBRARY)
  export LD_RUN_PATH=$(LD_LIBRARY)
  JAVAC=$(JDKDIR)/bin/javac -g -deprecation -classpath $(JPESRCDIR)
  JAVAH=$(JDKDIR)/bin/javah -force -verbose -classpath $(JPESRCDIR)
  JAVA=$(JDKDIR)/bin/java -classpath $(JPESRCDIR)\
 -Djava.library.path=$(JPESRCDIR)
#-verbose
  JPELIB=$(LIBPREF)jpe.$(SOEXT)
  LD=ld
  LDSHARED=$(LD) -shared -g
  PYMODEXT=module
endif

%.class: %.java
	$(JAVAC) $<
%.h: %.class
	$(JAVAH) $*

.PRECIOUS: %.class
.PRECIOUS: %.h


INCLUDES=$(PYINCLUDE) $(JNIINCLUDES)
CPPFLAGS=$(DEFINES) $(INCLUDES)

#export PYTHONPATH=$(JPESRCDIR)
export CLASSPATH=$(JAVAPATH)
