/*
 * The contents of this file are subject to the Mozilla Public
 * License Version 1.1 (the "License"); you may not use this file
 * except in compliance with the License. You may obtain a copy of
 * the License at http://www.mozilla.org/MPL/
 * 
 * Software distributed under the License is distributed on an "AS
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
 * implied. See the License for the specific language governing
 * rights and limitations under the License.
 * 
 * The Original Code is "Java-Python Extension (JPE)".
 * 
 * The Initial Developer of the Original Code is Frederic Bruno Giacometti.
 * Portions created by Frederic Bruno Giacometti are
 * Copyright (C) 2000-2001 Frederic Bruno Giacometti. All Rights Reserved.
 * 
 * Contributor(s): frederic.giacometti@arakne.com
 *
 * Acknowledgments:
 * Particular gratitude is expressed to the following parties for their
 * contributing support to the development of JPE:
 *     - Arakne SARL (France) and its staff (http://www.arakne.com);
 *       and in particular to Jean Hemmi, Marie-Therese Plaze and Didier Rano
 *     - The European Union through its funding of the IST Alice project
 *     - Dean Vucinic from Vrije Universiteit Brussel (Belgium),
 *       coordinator of the IST Alice project
 *     - iPhrase Technologies Inc. (Massachusetts, USA)
 */

package jpetest;

import java.security.SecureClassLoader;

import python.PyModule;
import python.PyObject;

public class pythontest extends junit.framework.TestCase
{
  public pythontest( String name) { super( name); }
  public void test001()
  {
    PyModule main = PyModule.Builtins;
    System.out.println( main.toString());
  }
  public void test002()
  {
//     PyModule os = new PyModule( "os");
//     PyObject res = (PyObject)os.callMethod( "dir");
    PyModule sys = new PyModule( "sys");
    System.out.println( "t002a");
    PyObject stdout = (PyObject)sys.getattr( "stdout");
    stdout.callMethod( "write", new python.PyString( "some string\n"));
    System.out.println( "t002d");
  }
  public void test003() throws ClassNotFoundException
  {
    Class myclass;

    myclass = Class.forName( "java.lang.Thread");
    System.out.println( "java.lang.Thread:" + myclass.toString());

    //myclass = Class.forName( "python.PyThreadState");
    //System.out.println( "python.PyThreadState:" + myclass.toString());

    myclass = Class.forName( "python.PyMapping");
    System.out.println( "python.PyMapping:" + myclass.toString());
  }
  public static void main( String args[])
  {
    PyModule sys = new PyModule( "sys");
    System.out.println( "t002a");
    PyObject stdout = (PyObject)sys.getattr( "stdout");
    System.out.println( "t002b");
    stdout.callMethod( "write", "some string\n");
    System.out.println( "t002c");
  }
}
