# 
# The contents of this file are subject to the Mozilla Public
# License Version 1.1 (the "License"); you may not use this file
# except in compliance with the License. You may obtain a copy of
# the License at http://www.mozilla.org/MPL/
# 
# Software distributed under the License is distributed on an "AS
# IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
# implied. See the License for the specific language governing
# rights and limitations under the License.
# 
# The Original Code is "Java-Python Extension (JPE)".
# 
# The Initial Developer of the Original Code is Frederic Bruno Giacometti.
# Portions created by Frederic Bruno Giacometti are
# Copyright (C) 2000-2001 Frederic Bruno Giacometti. All Rights Reserved.
# 
# Contributor(s): frederic.giacometti@arakne.com
#
# Acknowledgments:
# Particular gratitude is expressed to the following parties for their
# contributing support to the development of JPE:
#     - Arakne SARL (France) and its staff (http://www.arakne.com);
#       and in particular to Jean Hemmi, Marie-Therese Plaze and Didier Rano
#     - The European Union through its funding of the IST Alice project
#     - Dean Vucinic from Vrije Universiteit Brussel (Belgium),
#       coordinator of the IST Alice project
#     - iPhrase Technologies Inc. (Massachusetts, USA)
#

import unittest

class JpeTestCase( unittest.TestCase):
    def test008( self):
        from java import javalib
        
        classfound = javalib.jclass( 'python/PyThreadState')
        print "javalib.jclass( 'python/PyThreadState'): <%s>" % classfound
        
        classfound = javalib.jclass( 'python/PyObject')
        print "javalib.jclass( 'python/PyObject'): <%s>" % classfound
        
        classfound = javalib.jclass( 'python/PyMapping')
        print "javalib.jclass( 'python/PyMapping'): <%s>" % classfound

    def test0085( self):
        from java import getJclass, Jstring
        
        Class = getJclass( 'java.lang.Class')
        print "getJclass( 'java.lang.Class') <%s>" % Class
        
        Thread = Class.forName( Jstring( 'java.lang.Thread'))
        print "Class.forName( 'java.lang.Thread') <%s>" % Thread

        #PyThreadState = Class.forName( Jstring( 'python.PyThreadState'))
        #print "Class.forName( 'python.ThreadState') <%s>" % Thread

        #oClass = Class.forName( Jstring( 'java.lang.Class'))
        #print "Class.forName( 'java.lang.Class') <%s>" % oClass

        #loader = oClass.getClassLoader()
        #print 'Class.getClassLoader() <%s>' % loader
        
        #if loader is not None: ## never executed .... ?
            #PyThreadState = Class.forName( Jstring( 'python.PyThreadState'),
                                           #1, loader)
            #print "Class.forName( 'python.PyThreadState') <%s>" % PyThreadState

    def test009( self):
        from java import javalib
        
        classfound = javalib.jclassForName( 'java.lang.Thread')
        print "javalib.jclassForName( 'java.lang.Thread'): <%s>"\
              % classfound
        
##        classfound = javalib.jclassForName( 'python.PyThreadState')
##        print "javalib.jclassForName( 'python.PyThreadState'): <%s>"\
##              % classfound
        
##        classfound = javalib.jclassForName( 'python.PyObject')
##        print "javalib.jclassForName( 'python.PyObject'): <%s>" % classfound
        
##        classfound = javalib.jclassForName( 'python.PyMapping')
##        print "javalib.jclassForName( 'python.PyMapping'): <%s>" % classfound

    def test0095( self):
        from java import getJclass
        Runtime = getJclass( 'java.lang.Runtime')
        oruntime = Runtime.getRuntime()
        assert oruntime is not None
        oruntime.traceMethodCalls( 1)
        oruntime.traceInstructions( 1)
        print 'oruntime.totalMemory() <%s>' % oruntime.totalMemory()
        print 'oruntime.freeMemory() <%s>' % oruntime.freeMemory()
        oruntime.traceInstructions( 0)
        oruntime.traceMethodCalls( 0)

    def test0096( self):
        from java import javalib
        d = { 'a': 1}
        prox = javalib.jproxy( d)
        print 'javalib.jproxy( d) <%s>' % prox
        pclass = prox.getClass()
        print 'prox.getClass() <%s>' % pclass
        
        
    def test0097( self):
        from java import getJclass
        PyMapping = getJclass( 'python.PyMapping')
        print "getJclass( 'python.PyMapping') <%s>" % PyMapping
        class Tu:
            pass
        d = Tu()
        print 'id( d) <%s>' % id( d)
        mapobj = PyMapping( d)
        print mapobj

    def test010( self):
        from java import getJclass
        testdict = { 'a': 1, 'b': 'd', 4: '2001' }
        PyMapping = getJclass( 'python.PyMapping')
        print "getJclass( 'python.PyMapping') <%s>" % PyMapping
        mapobj = PyMapping( testdict)
        print mapobj

    def test011( self):
        from java import getJclass
        PyMapping = getJclass( 'python.PyMapping')
        mapobj = PyMapping( {})
        mapClass = mapobj.getClass()
        print 'mapobj.getClass() <%s>' % mapClass
        pack = mapClass.getPackage()
        print  'mapClass.getPackage() <%s>' % pack
        print 'pack.getName() <%s>' % pack.getName()
        print 'pack.getSpecificationTitle() <%s>'\
              % pack.getSpecificationTitle()
        print 'pack.getImplementationTitle() <%s>'\
              % pack.getImplementationTitle()

    def test012( self):
        from java import getJclass
        props = getJclass( 'java.lang.System').getProperties()
        penum = props.propertyNames()
        while penum.hasMoreElements():
            name = penum.nextElement()
            print '%s=<%s>' % (name, props.getProperty( name))

    def test013( self):
        from java import getJclass
        Package = getJclass( 'java.lang.Package')
        packs = Package.getPackages()
        print 'Package.getPackages() <%s>' % packs
        print 'packs.getClass <%s>' % packs.getClass()
        print 'packs.getClass.isArray() <%s>' % packs.getClass().isArray()
        print 'len( packs) <%s>' % len( packs)
        for pack in packs:
            print '\t%s' % pack

jpesuite = unittest.makeSuite( JpeTestCase)

if __name__ == '__main__':
    import java, sys, os
    if 1 < sys.version_info[ 0]:
        import gc # python 2.0 stuff
        gc.disable()
    gc.set_debug( gc.DEBUG_STATS)
    if not java.isInitialized():
        jvmargs = [ #'-Xcheck:jni',
            '-verbose:jni,gc', #class
            '-Djava.library.path=%s' % os.environ[ 'JPESRCDIR'],
            '-Djava.class.path=' + os.environ[ 'CLASSPATH'],
            ]
        print 'jvmargs:', jvmargs
        java.initialize( os.environ[ 'JRE_LIBJVM'], jvmargs)
    
    from java.test import suite
    jvmsuite = suite
    #allsuite = unittest.TestSuite( (jvmsuite, jpesuite))
    allsuite = unittest.TestSuite( (jpesuite,))
    
    unittest.TextTestRunner().run( allsuite)
    
